import { FastifyInstance, FastifyRequest, FastifyReply } from 'fastify';
import Command from './command';
declare type ApplicationArgs = {
    applicationID: string;
    publicKey: string;
    token: string;
    port?: number;
};
declare type ServerCallback = (app: FastifyInstance) => (request: FastifyRequest, response: FastifyReply) => unknown;
export default class Application {
    #private;
    constructor({ applicationID, publicKey, token, port }: ApplicationArgs);
    addCommand(command: Command): this;
    addCommands(...commands: Command[]): this;
    updateCommands(): Promise<this>;
    startServer(callback?: ServerCallback): void;
}
export {};
//# sourceMappingURL=application.d.ts.map