import type { ApplicationCommand } from './api/api';
import Application from './application';
import { Input } from './components/inputs';
import Interaction from './interaction';
declare type CommandArgs = {
    name: string;
    description: string;
    defaultPermission?: boolean;
    options?: Input[];
    handler: (interaction: Interaction) => unknown;
};
export default class Command {
    #private;
    name: string;
    handler: (interaction: Interaction, application: Application) => unknown;
    constructor({ name, description, options, handler, defaultPermission }: CommandArgs);
    group(): void;
    subcommand(): void;
    isEqualTo(schema: ApplicationCommand): boolean;
    toJSON(): {
        name: string;
        description: string;
    };
}
export {};
//# sourceMappingURL=command.d.ts.map