import { ApplicationCommandOptionType } from '../api/api';
declare type InputArgs = {
    type: ApplicationCommandOptionType;
    name: string;
    description: string;
    required?: boolean;
};
export declare class Input {
    constructor({ type, name, description, required }: InputArgs);
}
export declare class StringInput extends Input {
    constructor(args: Omit<InputArgs, 'type'>);
}
export declare class IntegerInput extends Input {
    constructor(args: Omit<InputArgs, 'type'>);
}
export declare class BooleanInput extends Input {
    constructor(args: Omit<InputArgs, 'type'>);
}
export declare class UserInput extends Input {
    constructor(args: Omit<InputArgs, 'type'>);
}
export declare class ChannelInput extends Input {
    constructor(args: Omit<InputArgs, 'type'>);
}
export declare class RoleInput extends Input {
    constructor(args: Omit<InputArgs, 'type'>);
}
export declare class MentionableInput extends Input {
    constructor(args: Omit<InputArgs, 'type'>);
}
export {};
//# sourceMappingURL=inputs.d.ts.map